/*
 * uart.c
 *
 * Created: 19.08.2014 18:25:42
 *  Author: sschultewolter
 */ 

#include "uart.h"

FILE mystdout = FDEV_SETUP_STREAM(uart_putchar, uart_getchar, _FDEV_SETUP_RW);

// Initialisierung der UART Schnittstelle
void uart_init()
{
	if ((F_CPU / 16L / UART_BAUD - 1) > 30)
	{
		UBRR0L = (unsigned char)(F_CPU /16L / UART_BAUD - 1);
		UBRR0H = (unsigned char)((F_CPU / 16L / UART_BAUD - 1) >> 8);
		UCSR0A = 0;
	}
	else
	{
		//Falls Teilerwert zu klein => Rundungsfehler
		//Daher doppelte Rate waehlen
		UBRR0L = (unsigned char)(F_CPU / 8L / UART_BAUD - 1);
		UBRR0H = (unsigned char)((F_CPU / 8L / UART_BAUD - 1) >> 8);
		UCSR0A = (1 << U2X0);
	}
	
	UCSR0B = UCSR0B | (1 << TXEN0) | (1 << RXEN0);
	UCSR0C = UCSR0C | (1 << UMSEL01) | (1 << UCSZ01) |
	(1 << UCSZ00);
	
	stdout = stdin = &mystdout;
}

// Sendet 1 Byte an UART
int8_t uart_putchar(char data, FILE* stream)
{
	while (!(UCSR0A & (1 << UDRE0)));
	UDR0 = (char)data;
	return 0;
}

// Empfaengt 1 Byte vom UART
int8_t uart_getchar(FILE *STREAM)
{
	while (!(UCSR0A & (1 << RXC0)));
	return (UDR0);
}